ompi/mca/mpool/mpool.h File Reference.TH "ompi/mca/mpool/mpool.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/mpool/mpool.h \- Description of the Memory Pool framework. 
.SH SYNOPSIS
.br
.PP
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'info/info.h'\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'ompi/class/ompi_pointer_array.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_MPOOL_FLAGS_CACHE\fP   0x1"
.br
.ti -1c
.RI "#define \fBMCA_MPOOL_FLAGS_PERSIST\fP   0x2"
.br
.ti -1c
.RI "#define \fBMCA_MPOOL_FLAGS_MPI_ALLOC_MEM\fP   0x4"
.br
.ti -1c
.RI "#define \fBMCA_MPOOL_REG_RETAIN\fP(reg)"
.br
.ti -1c
.RI "#define \fBMCA_MPOOL_REG_RELEASE\fP(reg)"
.br
.ti -1c
.RI "#define \fBMCA_MPOOL_BASE_VERSION_1_0_0\fP"
.br
.RI "\fIMacro for use in components that are of type mpool v1.0.0. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef mca_mpool_base_registration_t \fBmca_mpool_base_registration_t\fP"
.br
.ti -1c
.RI "typedef \fBmca_mpool_base_module_t\fP *(* \fBmca_mpool_base_component_init_fn_t\fP )(struct mca_mpool_base_resources_t *)"
.br
.RI "\fIcomponent initialize \fP"
.ti -1c
.RI "typedef void *(* \fBmca_mpool_base_module_alloc_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *mpool, size_t size, size_t align, uint32_t flags, mca_mpool_base_registration_t **registration)"
.br
.RI "\fIallocate function typedef \fP"
.ti -1c
.RI "typedef void *(* \fBmca_mpool_base_module_realloc_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *mpool, void *addr, size_t size, mca_mpool_base_registration_t **registration)"
.br
.RI "\fIrealloc function typedef \fP"
.ti -1c
.RI "typedef void(* \fBmca_mpool_base_module_free_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *mpool, void *addr, mca_mpool_base_registration_t *registration)"
.br
.RI "\fIfree function typedef \fP"
.ti -1c
.RI "typedef int(* \fBmca_mpool_base_module_register_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *mpool, void *addr, size_t size, uint32_t flags, mca_mpool_base_registration_t **registration)"
.br
.RI "\fIregister memory \fP"
.ti -1c
.RI "typedef int(* \fBmca_mpool_base_module_deregister_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *mpool, mca_mpool_base_registration_t *registration)"
.br
.RI "\fIderegister memory \fP"
.ti -1c
.RI "typedef int(* \fBmca_mpool_base_module_find_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *mpool, void *addr, size_t size, \fBompi_pointer_array_t\fP *regs, uint32_t *cnt)"
.br
.RI "\fIfind registrations in this memory pool \fP"
.ti -1c
.RI "typedef int(* \fBmca_mpool_base_module_retain_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *mpool, mca_mpool_base_registration_t *registration)"
.br
.RI "\fIretain registration \fP"
.ti -1c
.RI "typedef int(* \fBmca_mpool_base_module_release_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *mpool, mca_mpool_base_registration_t *registration)"
.br
.RI "\fIrelease registration \fP"
.ti -1c
.RI "typedef void *(* \fBmca_mpool_base_module_address_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *mpool)"
.br
.RI "\fIif appropriate - returns base address of memory pool \fP"
.ti -1c
.RI "typedef void(* \fBmca_mpool_base_module_finalize_fn_t\fP )(struct \fBmca_mpool_base_module_t\fP *)"
.br
.RI "\fIfinalize \fP"
.ti -1c
.RI "typedef \fBmca_mpool_base_component_1_0_0_t\fP \fBmca_mpool_base_component_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBmca_mpool_base_component_1_0_0_t\fP \fBmca_mpool_base_component_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBmca_mpool_base_module_t\fP \fBmca_mpool_base_module_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBOBJ_CLASS_DECLARATION\fP (mca_mpool_base_registration_t)"
.br
.ti -1c
.RI "OMPI_DECLSPEC void * \fBmca_mpool_base_alloc\fP (size_t size, struct ompi_info_t *info)"
.br
.RI "\fIFunction to allocate special memory according to what the user requests in the info object. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_mpool_base_free\fP (void *base)"
.br
.RI "\fIFunction to free memory previously allocated by mca_mpool_base_alloc. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_mpool_base_tree_node_compare\fP (void *key1, void *key2)"
.br
.RI "\fIFunction for the red black tree to compare 2 keys. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_mpool_base_insert\fP (void *addr, size_t size, \fBmca_mpool_base_module_t\fP *mpool, void *user_in, mca_mpool_base_registration_t *registration)"
.br
.ti -1c
.RI "OMPI_DECLSPEC int \fBmca_mpool_base_remove\fP (void *base)"
.br
.in -1c
.SH "Detailed Description"
.PP 
Description of the Memory Pool framework. 


.SH "Define Documentation"
.PP 
.SS "#define MCA_MPOOL_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* mpool v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* mpool v1.0 */ \
  'mpool', 1, 0, 0
.fi
Macro for use in components that are of type mpool v1.0.0. 
.PP
.SS "#define MCA_MPOOL_REG_RELEASE(reg)"
.PP
\fBValue:\fP
.PP
.nf
{ \
 do{ \
 OPAL_THREAD_ADD32(&reg->ref_count, -1); \
 } while(0); \
}
.fi
.SS "#define MCA_MPOOL_REG_RETAIN(reg)"
.PP
\fBValue:\fP
.PP
.nf
{ \
 do{ \
 OPAL_THREAD_ADD32(&reg->ref_count, 1); \
 } while(0); \
}
.fi
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC void* mca_mpool_base_alloc (size_t size, struct ompi_info_t * info)"
.PP
Function to allocate special memory according to what the user requests in the info object. 
.PP
If the user passes in a valid info structure then the function will try to allocate the memory and register it with every mpool that there is a key for it in the info struct. If it fails at registering the memory with one of the requested mpools, an error will be returned. Also, if there is a key in info that does not match any mpool, an error will be returned.
.PP
If the info parameter is MPI_INFO_NULL, then this function will try to allocate the memory and register it wih as many mpools as possible. However, if any of the registratons fail the mpool will simply be ignored.
.PP
\fBParameters:\fP
.RS 4
\fIsize\fP the size of the memory area to allocate 
.br
\fIinfo\fP an info object which tells us what kind of memory to allocate
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIpointer\fP to the allocated memory 
.br
\fINULL\fP on failure 
.RE
.PP

.SS "OMPI_DECLSPEC int mca_mpool_base_free (void * base)"
.PP
Function to free memory previously allocated by mca_mpool_base_alloc. 
.PP
\fBParameters:\fP
.RS 4
\fIbase\fP pointer to the memory to free
.RE
.PP
\fBReturn values:\fP
.RS 4
\fIOMPI_SUCCESS\fP .br
\fIOMPI_ERR_BAD_PARAM\fP if the passed base pointer was invalid 
.RE
.PP

.SS "OMPI_DECLSPEC int mca_mpool_base_tree_node_compare (void * key1, void * key2)"
.PP
Function for the red black tree to compare 2 keys. 
.PP
\fBParameters:\fP
.RS 4
\fIkey1\fP a pointer to the 1st key 
.br
\fIkey2\fP a pointer to the second key
.RE
.PP
\fBReturn values:\fP
.RS 4
\fI-1\fP if key1 is below key2 
.br
\fI1\fP if key 1 is above key2 
.br
\fI0\fP if the keys are the same 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
